Toolbar widget
The Toolbar widget is a component used for creating button and icon panels in web applications.
It allows developers to easily integrate interactive toolbars into their user interfaces.
The widget is licensed under the MIT license.
Quick start
First steps
To start with the widget, add the necessary package to your project first.
npm install @svar-ui/react-core
npm install @svar-ui/react-toolbar
or
yarn add @svar-ui/react-core
yarn add @svar-ui/react-toolbar
Now, import the widget into your project.
import { Willow } from "@svar-ui/react-core";
import { Toolbar } from "@svar-ui/react-toolbar";
function App() {
return (
<Willow>
<Toolbar />
</Willow>
);
}
The Willow component is a default theme wrapper that adds necessary styles for all SVAR widgets. The Toolbar component may work without it, but it will not have any styles, and it will be necessary to add them manually. It is a common approach to add the Willow tag once at the top level of the application.
Full init code
To see the widget in action, add some items to the toolbar.
import { Toolbar } from "@svar-ui/react-toolbar";
import { Willow } from "@svar-ui/react-core";
const items = [
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
},
];
function handler(ev) {
console.log(`item ${ev.id} was clicked`);
}
function App() {
return (
<Willow>
<Toolbar items={items} onClick={handler} />
</Willow>
);
}
Make sure you apply a theme if you use the Toolbar component standalone. Please, refer to applying a theme for more information.
Visual themes
The widget is provided in two visual styles - Light and Dark, which are controlled by the theme tag.
import { Willow, WillowDark } from "@svar-ui/react-core";
function AppLight() {
return (
<Willow>
<Toolbar />
</Willow>
);
}
function AppDark() {
return (
<WillowDark>
<Toolbar />
</WillowDark>
);
}
Defining toolbar elements
The toolbar widget provides the ability to include various components, such as buttons, icons, labels, and form elements. These components can be configured and customized to suit specific application needs. Below are examples demonstrating how to define different components in the toolbar.
Adding a button to the Toolbar
const items = [
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
handler: onClick,
},
];
function onClick(ev) {
console.log(ev);
}
function App() {
return <Toolbar items={items} onClick={onClick} />;
}
Buttons are suitable for triggering actions or events, such as submitting forms or performing searches. The id uniquely identifies the button, comp specifies the type as "button", and icon adds a predefined icon. The optional css parameter can control the button's alignment, and handler assigns a function for handling click events. Use the Toolbar onClick prop to handle clicks globally.
Related sample: Button types
Adding an icon to the Toolbar
function App() {
return <Toolbar items={[{ comp: "icon", icon: "wxi-search" }]} />;
}
Icons can be used to display visual cues or shortcuts. The comp property defines the component type as "icon", and icon assigns the specific visual representation. This is useful for adding static icons without additional functionality.
Adding a label to the Toolbar
function App() {
return <Toolbar items={[{ text: "My App" }]} />;
}
Labels are ideal for displaying static text, such as the application name or section titles. The text property holds the displayed text content.
Adding a checkbox to the Toolbar
import { Checkbox } from "@svar-ui/react-core";
function App() {
return (
<Toolbar items={[{ id: "check", comp: Checkbox }]} values={{ check: true }} />
);
}
Checkboxes are used for binary choices, such as toggling features on or off. The comp property specifies the Checkbox component, and values provides the initial checked state.
Adding a combo box to the Toolbar
import { Combo } from "@svar-ui/react-core";
function App() {
return (
<Toolbar
items={[
{
id: "lead",
comp: Combo,
options: [
{ id: 1, label: "Kristina" },
{ id: 2, label: "Dorian" },
],
},
]}
values={{ lead: 1 }}
/>
);
}
Combo boxes allow users to select a value from a dropdown list. The comp property references the Combo component, and options defines the selectable items. The values property sets the initial selection.
Adding a datepicker to the Toolbar
import { Datepicker } from "@svar-ui/react-core";
function App() {
return (
<Toolbar items={[{ id: "date", comp: Datepicker }]} values={{ date: new Date() }} />
);
}
Datepickers enable users to select dates. The comp property specifies the Datepicker component, and values sets the default date.
Adding a radio group to the Toolbar
import { RadioGroup } from "@svar-ui/react-core";
function App() {
return (
<Toolbar
items={[
{
id: "radio",
comp: RadioGroup,
options: [
{ id: 1, label: "Kristina" },
{ id: 2, label: "Dorian" },
],
},
]}
values={{ radio: 1 }}
/>
);
}
Radio groups are ideal for selecting a single option from multiple choices. The comp references the RadioGroup component, and options defines the available choices. The values property determines the default selection.
Adding a richselect to the Toolbar
import { Richselect } from "@svar-ui/react-core";
function App() {
return (
<Toolbar
items={[
{
id: "lead",
comp: Richselect,
options: [
{ id: 1, label: "Kristina" },
{ id: 2, label: "Dorian" },
],
},
]}
values={{ lead: 1 }}
/>
);
}
Richselect components are advanced dropdowns with enhanced styling and interaction. The comp specifies Richselect, and options provides the dropdown items. The values sets the initial selected item.
Adding a slider to the Toolbar
import { Slider } from "@svar-ui/react-core";
function App() {
return (
<Toolbar
items={[{ id: "limit", comp: Slider, min: 2, max: 20 }]}
values={{ limit: 10 }}
/>
);
}
Sliders are used for selecting values within a range. The comp references the Slider component, min and max define the range, and values sets the initial value.
Adding a text input to the Toolbar
import { Text } from "@svar-ui/react-core";
function App() {
return <Toolbar items={[{ id: "name", comp: Text }]} values={{ name: "John" }} />;
}
Text inputs allow users to enter text data. The comp specifies the Text component, and values sets the default text. This is useful for capturing user input, such as names or search queries.
Grouping items
The toolbar widget offers flexible options for grouping items in rows, columns, or a combination of both. This allows developers to organize buttons, icons, and other elements in layouts that fit the application's interface requirements.
The layout field on a group item controls the flex direction within that group. To change the orientation of the entire toolbar, use the top-level layout prop (see Changing Toolbar orientation).
Defining a group of items in a row
function App() {
return (
<Toolbar
items={[
{ label: "My App" },
{
layout: "row",
items: [
{ comp: "icon", id: "add", icon: "wxi-plus" },
{ comp: "icon", id: "edit", icon: "wxi-pencil" },
{ comp: "icon", id: "delete", icon: "wxi-trash" },
],
},
]}
/>
);
}
This configuration organizes toolbar items in a horizontal layout. Each icon (add, edit, delete) appears in a single row. It is suitable for cases where users need to access multiple related actions side by side, such as editing or managing items in a list.
Defining a group of items in a column
function App() {
return (
<Toolbar
items={[
{ label: "My App" },
{
layout: "column",
items: [
{ comp: "icon", id: "add", icon: "wxi-plus" },
{ comp: "icon", id: "edit", icon: "wxi-pencil" },
{ comp: "icon", id: "delete", icon: "wxi-trash" },
],
},
]}
/>
);
}
In this example, toolbar items are grouped into a vertical layout. Each icon is displayed one below the other. This layout works well in situations where space is constrained horizontally or when grouping actions in a sidebar.
Creating a multiline Toolbar
function App() {
return (
<Toolbar
items={[
{
layout: "column",
items: [
{
layout: "row",
items: [
{
id: "font-family",
comp: "richselect",
},
{
id: "font-size",
comp: "richselect",
},
],
},
{
layout: "row",
items: [
{
id: "font-bold",
comp: "icon",
icon: "wxi-bold",
},
{
id: "font-italic",
comp: "icon",
icon: "wxi-italic",
},
{
id: "font-underline",
comp: "icon",
icon: "wxi-underline",
},
],
},
],
},
]}
/>
);
}
This setup creates a toolbar with multiple rows grouped into a column layout. The first row contains dropdowns for font-family and font-size, while the second row includes buttons for text formatting (bold, italic, underline). It is ideal for text editors or similar applications where controls are grouped by functionality.
Related sample: Multiline
Mixing columns and rows in a Toolbar
function App() {
return (
<Toolbar
items={[
{ id: "label", text: "My App" },
{
layout: "column",
items: [
{ text: "Actions" },
{
layout: "row",
items: [
{
comp: "icon",
icon: "wxi-search",
},
{
comp: "icon",
icon: "wxi-trash",
},
],
},
],
},
]}
/>
);
}
This configuration combines column and row layouts.
Toolbar layout
Options for organizing and displaying items within the toolbar. These functionalities allow developers to structure toolbar items effectively for better usability and adaptability across different screen sizes.
Changing Toolbar orientation
By default, the Toolbar arranges its top-level items horizontally. Use the layout prop to make the entire toolbar vertical.
function App() {
return (
<Toolbar
layout="column"
items={[
{ comp: "icon", icon: "wxi-search" },
{ comp: "icon", icon: "wxi-plus" },
{ comp: "icon", icon: "wxi-pencil" },
]}
/>
);
}
This differs from item.layout, which controls the flex direction inside a single group, not the toolbar container itself.
Adding a separator between Toolbar items
function App() {
return (
<Toolbar
items={[
{ comp: "icon", icon: "wxi-search" },
{ comp: "separator" },
{ comp: "icon", icon: "wxi-plus" },
]}
/>
);
}
Separators are used to create visual divisions between toolbar items. This is useful for grouping related actions or icons, making the interface more organized and easier to navigate. In the above example, a separator is placed between two icons to visually distinguish their functionalities.
Aligning Toolbar items to the right
function App() {
return (
<Toolbar
items={[
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
comp: "icon",
icon: "wxi-search",
css: "right",
},
]}
/>
);
}
A spacer component can be used to push items such as icons or buttons to the right side of the toolbar. This approach is commonly applied to balance the layout, for example, placing a logo or title on the left and actionable icons on the right.
Collapsing button groups into an icon on overflow
function App() {
return (
<Toolbar
overflow="collapse"
items={[
{
id: "font-family",
comp: "richselect",
},
{
id: "font-size",
comp: "richselect",
},
{
// this group may collapse on overflow
layout: "row",
items: [
{
id: "font-bold",
comp: "icon",
icon: "wxi-bold",
},
{
id: "font-italic",
comp: "icon",
icon: "wxi-italic",
},
{
id: "font-underline",
comp: "icon",
icon: "wxi-underline",
},
],
},
]}
/>
);
}
When the toolbar cannot display all items due to limited screen space, grouped buttons can collapse into a single icon. This functionality is essential for creating responsive toolbars that adapt to smaller screens. Groups should be defined with a layout: "row" block to enable this behavior. For collapsing the entire toolbar, all items should be wrapped in a top-level row block.
Related sample: Collapsed sections
Wrapping toolbar items to the next line on overflow
function App() {
return <Toolbar overflow="wrap" />;
}
The default behavior of the toolbar is to wrap items to the next line when there is not enough space. This approach works well for toolbars that need to display all items without hiding or collapsing them, ensuring visibility at all times.
Related sample: Overflow wrap
Moving overflow items into a popup menu
function App() {
return <Toolbar overflow="menu" />;
}
Items that cannot fit into the visible toolbar can be moved into a popup menu. This is useful for reducing visual clutter while still providing access to all toolbar options. The overflow menu is particularly effective in scenarios where a clean appearance is prioritized.
Related sample: Overflow menu
Popup menu configuration
The widget allows for the management of controls in a popup menu by enabling the grouping of elements and customizing the appearance of the popup container. It provides flexibility in organizing and styling toolbar components.
Moving controls to a popup panel
By grouping controls into a "collapsed" layout, these controls are hidden by default and represented by an icon. Clicking the icon expands the group into a popup menu, displaying its content. This feature is useful for organizing toolbar items when screen space is limited or to improve accessibility by grouping related actions.
function App() {
return (
<Toolbar
items={[
{ id: "label", text: "My App" },
{
layout: "row",
collapsed: true,
icon: "wxi-group",
text: "Actions",
items: [
{
comp: "icon",
icon: "wxi-search",
},
{
comp: "icon",
icon: "wxi-trash",
},
],
},
]}
/>
);
}
In this example, the toolbar includes a label "My App" and a collapsed group labeled "Actions". The group is represented by the "wxi-group" icon. This setup is beneficial for creating a clean and compact toolbar while still providing access to essential tools.
Defining a CSS class for the popup menu container
A custom CSS class can be applied to the top container of the popup menu to modify its appearance. This is helpful when the default styling does not meet the design requirements, allowing for a tailored look and feel.
function App() {
return <Toolbar menuCss="somemenu" />;
}
/* CSS */
.somemenu {
background-color: #f0f0f0;
}
In this snippet, the menuCss property is used to assign the "somemenu" class to the popup menu container. The associated CSS rule changes the background color of the popup menu to a light gray (#f0f0f0). This technique is practical for aligning the popup menu's appearance with the overall application theme or branding.
Event handling
The Toolbar widget provides methods to detect and respond to user interactions with its controls. Developers can use these methods to handle changes in control values and detect when specific controls are clicked.
Detecting changes in control values
This feature allows tracking when a user modifies the value of a control, such as a text input field. It is useful for scenarios like form building or data entry applications, where immediate feedback or processing is required upon value changes.
import { useState, useEffect } from "react";
import { Text } from "@svar-ui/react-core";
function App() {
const items = [
{ id: "name", comp: Text },
{ id: "email", comp: Text },
];
function handler(ev) {
const { item, value } = ev;
console.log("changed control", item.id);
console.log("new value", value);
}
return <Toolbar items={items} onChange={handler} />;
}
In this example, the items array defines two controls with IDs name and email, both using the Text component. The onChange event is triggered whenever the value of a control changes. The handler function receives an event object containing the item (the control) and the new value. This information is logged to the console, but it can be used for further processing or validation.
Detecting clicks on controls
This functionality is used to capture user clicks on controls, such as buttons. It is commonly applied in interactive toolbars where actions need to be performed when a button is pressed.
function App() {
const items = [
{ id: "name", comp: "button" },
{ id: "email", comp: "button" },
];
function handler(ev) {
const { item } = ev;
console.log("clicked control", item.id);
}
return <Toolbar items={items} onClick={handler} />;
}
Here, the items array defines two button controls with IDs name and email. The onClick event is triggered when a user clicks on any of these buttons. The handler function receives an event object containing the item (the control that was clicked). The control's ID is logged to the console, enabling developers to identify which button was clicked and execute corresponding actions.
Custom components
The toolbar widget allows developers to extend its functionality by creating and integrating custom components. These components can be registered and utilized to create customized toolbar elements, such as buttons or input fields, tailored to specific application needs.
Registering a custom component as a Toolbar element
Developers can register custom components as toolbar elements to enhance the toolbar's functionality. This feature is useful when creating reusable components that can be referenced across toolbars.
import { Toolbar, registerToolbarItem } from "@svar-ui/react-toolbar";
import { Text } from "@svar-ui/react-core";
// register custom component
registerToolbarItem("text", Text);
function App() {
return (
<Toolbar
items={[
{ id: "label", text: "Toolbar with text input" },
{ id: "search", comp: "text" },
]}
/>
);
}
In this case, the Text component is registered with the identifier "text". Once registered, the component can be used in the items array of the Toolbar by specifying its identifier in the comp property. This approach allows the inclusion of predefined or externally created components seamlessly in the toolbar.
Registering a separate renderer for the overflow menu
The overflow menu appears automatically when the toolbar doesn't have enough space to show all items. By default, a component registered with registerToolbarItem() looks the same both in the toolbar and in the overflow menu. To give menu items a different look, register a separate component for the menu mode and pass { menu: true } as the third argument to the function.
<script>
import { Toolbar, ButtonList, registerToolbarItem } from "@svar-ui/react-toolbar";
import { Segmented } from "@svar-ui/react-core";
// register component for the `toolbar` mode
registerToolbarItem("segmented", Segmented);
// register a separate component for the `menu` mode
registerToolbarItem("segmented", ButtonList, { menu: true });
function onClick(item) {
message = "Button '" + item.id + "' clicked";
}
const items = [
// ... more toolbar items
{
id: "mode",
comp: "segmented",
value: "1",
options: [
{ id: "1", label: "All" },
{ id: "2", label: "Active" },
],
handler: onClick,
},
];
</script>
<Toolbar items={items} />
Here, both Segmented and ButtonList are registered under the same "segmented" type. The toolbar item itself only needs to reference the shared type via comp: "segmented". The correct component is resolved automatically based on the item's current location without any extra logic on the application side:
Segmentedview is used when the item is rendered directly in the toolbar
ButtonListview is used if the same item collapses into the overflow menu

Creating a custom button control for the Toolbar
Custom button controls can be created to enhance user interaction within the toolbar. This functionality is helpful for buttons with specific styles or behaviors.
Definition in MyControl.jsx
export const MyControl = ({ menu, text, onClick }) => {
return (
<button className={menu ? "menu" : ""} onClick={onClick}>
{text}
</button>
);
};
This custom button component accepts two properties:
menu, which determines if the button is part of a popup menu (true when inside a menu).text, which specifies the button's label.
The button calls the onClick prop when clicked. The menu property is used to apply additional styles via the "menu" class.
/* MyControl.css */
.menu {
font-weight: bold;
}
Usage in App.jsx
import { Toolbar, registerToolbarItem } from "@svar-ui/react-toolbar";
import { MyControl } from "./MyControl.jsx";
// register custom component
registerToolbarItem("cb", MyControl);
function App() {
return (
<Toolbar
items={[
{ id: "label", text: "Toolbar with custom button" },
{ id: "search", comp: "cb" },
]}
/>
);
}
Here, the custom button is registered with the identifier "cb" and included in the toolbar by referencing it in the items array. Additional properties can be added to the item object and will be accessible in the custom button component.
Creating a Custom Input Control for the Toolbar
Custom input controls can be created to allow data entry directly within the toolbar. This is useful for search fields, text inputs, or other editable fields.
Definition in MyControl.jsx
export const MyControl = ({ value, type = "text", onChange }) => {
return (
<input
type={type}
value={value}
onChange={(e) => onChange && onChange(e.target.value)}
/>
);
};
This custom input component supports the following:
valueproperty, which holds the initial input value and updates the toolbar's state when modified.typeproperty, which defaults to "text" and determines the input type.onChangeprop is called with the new value when the input changes.
Any additional properties defined in the item object will also be accessible in the component (via props).
Usage in App.jsx
import { Toolbar, registerToolbarItem } from "@svar-ui/react-toolbar";
import { MyControl } from "./MyControl.jsx";
// register custom component
registerToolbarItem("ci", MyControl);
function App() {
return (
<Toolbar
items={[
{ id: "label", text: "Toolbar with custom input" },
{ id: "search", comp: "ci", type: "search" },
]}
/>
);
}
The custom input control is registered with the identifier "ci". It is then used in the toolbar with properties like type set in the items array. This enables the creation of specialized input fields, such as a search bar.
Toolbar initialization and control management
The toolbar widget allows developers to initialize a customizable toolbar and manage the values of its controls. The following sections explain how to set up the toolbar, retrieve control values, set initial values, and dynamically update control values.
Toolbar initialization
The toolbar can be initialized with predefined items such as labels, spacers, and buttons. Each item can be customized with properties like id, text, comp (component type), icon, and css classes. Event handling is supported to capture user interactions.
import { Toolbar } from "@svar-ui/react-toolbar";
const items = [
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
},
];
function handler(ev) {
console.log(`item ${ev.id} was clicked`);
}
function App() {
return <Toolbar items={items} onClick={handler} />;
}
This setup is useful for creating a toolbar with a combination of static labels, flexible spacers, and interactive buttons. The handler function logs the id of the clicked item, enabling easy tracking of user actions.
Retrieving current control values
The toolbar allows binding to a values object to track the current state of its controls. In React you typically hold values in state and listen to onChange events to keep it in sync.
import { useState, useEffect } from "react";
import { Text, Switch } from "@svar-ui/react-core";
function App() {
const [values, setValues] = useState({});
useEffect(() => {
console.log(JSON.stringify(values));
}, [values]);
function handleChange(ev) {
// ev: { item, value } - update the values object accordingly
setValues((prev) => ({ ...prev, [ev.item.key || ev.item.id]: ev.value }));
}
const items = [
{ comp: Text, key: "query" },
{ comp: Switch, key: "state" },
];
return <Toolbar items={items} values={values} onChange={handleChange} />;
}
This functionality is suitable for dynamic interfaces where control states need to be observed and logged. For example, it can be used to capture a search query and a toggle state simultaneously.
Setting initial values for controls
Initial values for toolbar controls can be predefined by passing a values object during initialization. The keys in the values object should match the key properties of the toolbar items.
const initialValues = { query: "something else", state: true };
function App() {
return (
<Toolbar
items={[
{ comp: Text, key: "query" },
{ comp: Switch, key: "state" },
]}
values={initialValues}
/>
);
}
This feature is especially useful for preloading a toolbar with default settings, such as a predefined search term or an active toggle switch.
Modifying control values dynamically
Control values in the toolbar can be updated programmatically by modifying the values object in your component state. This allows developers to reset or change control states based on application logic.
import { useState } from "react";
import { Switch, Text } from "@svar-ui/react-core";
function App() {
const items = [
{ type: "label", text: "Active Mode" },
{ comp: Switch, key: "state" },
];
const [values, setValues] = useState({ query: "something else", state: true });
// change value later on
const reset = () => {
setValues((v) => ({ ...v, state: false }));
};
return (
<>
<Toolbar
items={items}
values={values}
onChange={(ev) =>
setValues((prev) => ({ ...prev, [ev.item.key || ev.item.id]: ev.value }))
}
/>
<button onClick={reset}>Reset</button>
</>
);
}
This capability is ideal for scenarios where controls need to be reset or updated dynamically, such as toggling between different modes or clearing user inputs.

Skip to main content

Toolbar widget

The Toolbar widget is a component used for creating button and icon panels in web applications.

It allows developers to easily integrate interactive toolbars into their user interfaces.

The widget is licensed under the MIT license.

Quick start​

First steps​

To start with the widget, add the necessary package to your project first.

npm install @svar-ui/svelte-core
npm install @svar-ui/svelte-toolbar

or

yarn add @svar-ui/svelte-core
yarn add @svar-ui/svelte-toolbar

Now, import the widget into your project.

<script>
import { Willow } from '@svar-ui/svelte-core';
import { Toolbar } from '@svar-ui/svelte-toolbar';
</script>

<Willow>
<Toolbar />
</Willow>

The Willow component is a default theme wrapper that adds necessary styles for all SVAR widgets. The Toolbar component may work without it, but it will not have any styles, and it will be necessary to add them manually. It is a common approach to add the Willow tag once at the top level of the application.

Full init code​

To see the widget in action, add some items to the toolbar.

<script>
import { Toolbar } from "@svar-ui/svelte-toolbar";
import { Willow } from '@svar-ui/svelte-core';

const items = [
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
},
];

function handler(ev) {
console.log(`item ${ev.id} was clicked`);
}
</script>

<Willow>
<Toolbar {items} onclick={handler} />
</Willow>

Toolbar

note

Make sure you apply a theme if you use the Toolbar component standalone. Please, refer to applying a theme for more information.

Visual themes​

The widget is provided in two visual styles - Light and Dark, which are controlled by the theme tag.

<script>
import { Willow, WillowDark } from "@svar-ui/svelte-core";
</script>

<!-- Light -->
<Willow>
<Toolbar />
</Willow>

<!-- Dark -->
<WillowDark>
<Toolbar />
</WillowDark>

Toolbar dark themes

Defining toolbar elements​

The toolbar widget provides the ability to include various components, such as buttons, icons, labels, and form elements. These components can be configured and customized to suit specific application needs. Below are examples demonstrating how to define different components in the toolbar.

Adding a button to the Toolbar​

<script>
let items = [
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
handler: onClick,
},
];
</script>

<Toolbar {items} />

Buttons are suitable for triggering actions or events, such as submitting forms or performing searches. The id uniquely identifies the button, comp specifies the type as "button", and icon adds a predefined icon. The optional css parameter can control the button's alignment, and handler assigns a function for handling click events.

Adding an icon to the Toolbar​

<Toolbar items={[{ comp: "icon", icon: "wxi-search" }]} />

Icons can be used to display visual cues or shortcuts. The comp property defines the component type as "icon", and icon assigns the specific visual representation. This is useful for adding static icons without additional functionality.

Adding a label to the Toolbar​

<Toolbar items={[{ text: "My App" }]} />

Labels are ideal for displaying static text, such as the application name or section titles. The text property holds the displayed text content.

Adding a checkbox to the Toolbar​

<script>
import { Checkbox } from "@svar-ui/svelte-core";
</script>

<Toolbar items={[{ id: "check", comp: Checkbox }]} values={{ check: true }} />

Checkboxes are used for binary choices, such as toggling features on or off. The comp property specifies the Checkbox component, and values provides the initial checked state.

Adding a combo box to the Toolbar​

<script>
import { Combo } from "@svar-ui/svelte-core";
</script>

<Toolbar
items={[
{
id: "lead",
comp: Combo,
options: [
{ id: 1, label: "Kristina" },
{ id: 2, label: "Dorian" },
],
},
]}
values={{ lead: 1 }}
/>

Combo boxes allow users to select a value from a dropdown list. The comp property references the Combo component, and options defines the selectable items. The values property sets the initial selection.

Toolbar combo

Adding a datepicker to the Toolbar​

<script>
import { Datepicker } from "@svar-ui/svelte-core";
</script>

<Toolbar items={[{ id: "date", comp: Datepicker }]} values={{ date: new Date() }} />

Datepickers enable users to select dates. The comp property specifies the Datepicker component, and values sets the default date.

Toolbar datepicker

Adding a radio group to the Toolbar​

<script>
import { RadioGroup } from "@svar-ui/svelte-core";
</script>

<Toolbar
items={[
{
id: "radio",
comp: RadioGroup,
options: [
{ id: 1, label: "Kristina" },
{ id: 2, label: "Dorian" },
],
},
]}
values={{ radio: 1 }}
/>

Radio groups are ideal for selecting a single option from multiple choices. The comp references the RadioGroup component, and options defines the available choices. The values property determines the default selection.

Toolbar radiogroup

Adding a richselect to the Toolbar​

<script>
import { Richselect } from "@svar-ui/svelte-core";
</script>

<Toolbar
items={[
{
id: "lead",
comp: Richselect,
options: [
{ id: 1, label: "Kristina" },
{ id: 2, label: "Dorian" },
],
},
]}
values={{ lead: 1 }}
/>

Richselect components are advanced dropdowns with enhanced styling and interaction. The comp specifies Richselect, and options provides the dropdown items. The values sets the initial selected item.

Toolbar richselect

Adding a slider to the Toolbar​

<script>
import { Slider } from "@svar-ui/svelte-core";
</script>

<Toolbar
items={[{ id: "limit", comp: Slider, min: 2, max: 20 }]}
values={{ limit: 10 }}
/>

Sliders are used for selecting values within a range. The comp references the Slider component, min and max define the range, and values sets the initial value.

Toolbar slider

Adding a text input to the Toolbar​

<script>
import { Text } from "@svar-ui/svelte-core";
</script>

<Toolbar items={[{ id: "name", comp: Text }]} values={{ name: "John" }} />

Text inputs allow users to enter text data. The comp specifies the Text component, and values sets the default text. This is useful for capturing user input, such as names or search queries.

Toolbar text

Grouping items​

The toolbar widget offers flexible options for grouping items in rows, columns, or a combination of both. This allows developers to organize buttons, icons, and other elements in layouts that fit the application's interface requirements.

The layout field on a group item controls the flex direction within that group. To change the orientation of the entire toolbar, use the top-level layout prop (see Changing Toolbar orientation).

Defining a group of items in a row​

<Toolbar
items={[
{ label: "My App" },
{
layout: "row",
items: [
{ comp: "icon", id: "add", icon: "wxi-plus" },
{ comp: "icon", id: "edit", icon: "wxi-pencil" },
{ comp: "icon", id: "delete", icon: "wxi-trash" },
],
},
]}
/>

Group of items in a row

This configuration organizes toolbar items in a horizontal layout. Each icon (add, edit, delete) appears in a single row. It is suitable for cases where users need to access multiple related actions side by side, such as editing or managing items in a list.

Defining a group of items in a column​

<Toolbar
items={[
{ label: "My App" },
{
layout: "column",
items: [
{ comp: "icon", id: "add", icon: "wxi-plus" },
{ comp: "icon", id: "edit", icon: "wxi-pencil" },
{ comp: "icon", id: "delete", icon: "wxi-trash" },
],
},
]}
/>

Group of items in a column

In this example, toolbar items are grouped into a vertical layout. Each icon is displayed one below the other. This layout works well in situations where space is constrained horizontally or when grouping actions in a sidebar.

Creating a multiline Toolbar​

<Toolbar
items={[
{
layout: "column",
items: [
{
layout: "row",
items: [
{
id: "font-family",
comp: "richselect",
},
{
id: "font-size",
comp: "richselect",
},
],
},
{
layout: "row",
items: [
{
id: "font-bold",
comp: "icon",
icon: "wxi-bold",
},
{
id: "font-italic",
comp: "icon",
icon: "wxi-italic",
},
{
id: "font-underline",
comp: "icon",
icon: "wxi-underline",
},
],
},
],
},
]}
/>

Multiline toolbar

This setup creates a toolbar with multiple rows grouped into a column layout. The first row contains dropdowns for font-family and font-size, while the second row includes buttons for text formatting (bold, italic, underline). It is ideal for text editors or similar applications where controls are grouped by functionality.

Mixing columns and rows in a Toolbar​

<Toolbar
items={[
{ id: "label", text: "My App" },
{
layout: "column",
items: [
{ text: "Actions" },
{
layout: "row",
items: [
{
comp: "icon",
icon: "wxi-search",
},
{
comp: "icon",
icon: "wxi-trash",
},
],
},
],
},
]}
/>

Mixed column and row layout

This configuration combines column and row layouts.

Toolbar layout​

Options for organizing and displaying items within the toolbar. These functionalities allow developers to structure toolbar items effectively for better usability and adaptability across different screen sizes.

Changing Toolbar orientation​

By default, the Toolbar arranges its top-level items horizontally. Use the layout prop to make the entire toolbar vertical.

<Toolbar layout="column" items={[...]} />

Vertical toolbar

This differs from item.layout, which controls the flex direction inside a single group, not the toolbar container itself.

Adding a separator between Toolbar items​

<Toolbar
items={[
{ comp: "icon", icon: "wxi-search" },
{ comp: "separator" },
{ comp: "icon", icon: "wxi-plus" },
]}
/>

Separators are used to create visual divisions between toolbar items. This is useful for grouping related actions or icons, making the interface more organized and easier to navigate. In the above example, a separator is placed between two icons to visually distinguish their functionalities.

Aligning Toolbar items to the right​

<Toolbar
items={[
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
comp: "icon",
icon: "wxi-search",
css: "right",
},
]}
/>

A spacer component can be used to push items such as icons or buttons to the right side of the toolbar. This approach is commonly applied to balance the layout, for example, placing a logo or title on the left and actionable icons on the right.

Collapsing button groups into an icon on overflow​

<Toolbar
overflow="collapse"
items={[
{
id: "font-family",
comp: "richselect",
},
{
id: "font-size",
comp: "richselect",
},
{
// this group may collapse on overflow
layout: "row",
items: [
{
id: "font-bold",
comp: "icon",
icon: "wxi-bold",
},
{
id: "font-italic",
comp: "icon",
icon: "wxi-italic",
},
{
id: "font-underline",
comp: "icon",
icon: "wxi-underline",
},
],
},
]}
/>

Collapsed toolbar group on overflow

When the toolbar cannot display all items due to limited screen space, grouped buttons can collapse into a single icon. This functionality is essential for creating responsive toolbars that adapt to smaller screens. Groups should be defined with a layout: "row" block to enable this behavior. For collapsing the entire toolbar, all items should be wrapped in a top-level row block.

Wrapping toolbar items to the next line on overflow​

<Toolbar overflow="wrap" />

The default behavior of the toolbar is to wrap items to the next line when there is not enough space. This approach works well for toolbars that need to display all items without hiding or collapsing them, ensuring visibility at all times.

Moving overflow items into a popup menu​

<Toolbar overflow="menu" />

Items that cannot fit into the visible toolbar can be moved into a popup menu. This is useful for reducing visual clutter while still providing access to all toolbar options. The overflow menu is particularly effective in scenarios where a clean appearance is prioritized.

Pinning items to prevent overflow hiding​

When overflow="menu" is active, individual items can be pinned so they always remain visible in the toolbar regardless of available space. Set pinned: true on any item to keep it out of the overflow menu.

<Toolbar
overflow="menu"
items={[
{ id: "search", comp: "icon", icon: "wxi-search" },
{ id: "copy", comp: "icon", icon: "wxi-content-copy", menuText: "Copy" },
{ id: "edit", comp: "icon", icon: "wxi-edit-outline", menuText: "Edit", pinned: true },
{ id: "delete", comp: "icon", icon: "wxi-delete-outline", pinned: true },
]}
/>

The widget allows for the management of controls in a popup menu by enabling the grouping of elements and customizing the appearance of the popup container. It provides flexibility in organizing and styling toolbar components.

Moving controls to a popup panel​

By grouping controls into a "collapsed" layout, these controls are hidden by default and represented by an icon. Clicking the icon expands the group into a popup menu, displaying its content. This feature is useful for organizing toolbar items when screen space is limited or to improve accessibility by grouping related actions.

<Toolbar
items={[
{ id: "label", text: "My App" },
{
layout: "row",
collapsed: true,
icon: "wxi-group",
text: "Actions",
items: [
{
comp: "icon",
icon: "wxi-search",
},
{
comp: "icon",
icon: "wxi-trash",
},
],
},
]}
/>

Controls moved to popup panel

In this example, the toolbar includes a label "My App" and a collapsed group labeled "Actions". The group is represented by the "wxi-group" icon. This setup is beneficial for creating a clean and compact toolbar while still providing access to essential tools.

Defining a CSS class for the popup menu container​

A custom CSS class can be applied to the top container of the popup menu to modify its appearance. This is helpful when the default styling does not meet the design requirements, allowing for a tailored look and feel.

<script>
</script>

<Toolbar menuCss="somemenu" />

<style>
.somemenu {
background-color: #f0f0f0;
}
</style>

In this snippet, the menuCss property is used to assign the "somemenu" class to the popup menu container. The associated CSS rule changes the background color of the popup menu to a light gray (#f0f0f0). This technique is practical for aligning the popup menu's appearance with the overall application theme or branding.

Event handling​

The Toolbar widget provides methods to detect and respond to user interactions with its controls. Developers can use these methods to handle changes in control values and detect when specific controls are clicked.

Detecting changes in control values​

This feature allows tracking when a user modifies the value of a control, such as a text input field. It is useful for scenarios like form building or data entry applications, where immediate feedback or processing is required upon value changes.

<script>
const items = [
{ id: "name", comp: Text },
{ id: "email", comp: Text },
];
function handler(ev) {
const { item, value } = ev;
console.log("changed control", item.id);
console.log("new value", value);
}
</script>

<Toolbar {items} onchange={handler} />

In this example, the items array defines two controls with IDs name and email, both using the Text component. The onchange event is triggered whenever the value of a control changes. The handler function receives an event object containing the item (the control) and the new value. This information is logged to the console, but it can be used for further processing or validation.

Detecting clicks on controls​

This functionality is used to capture user clicks on controls, such as buttons. It is commonly applied in interactive toolbars where actions need to be performed when a button is pressed.

<script>
const items = [
{ id: "name", comp: "button" },
{ id: "email", comp: "button" },
];
function handler(ev) {
const { item } = ev;
console.log("clicked control", item.id);
}
</script>

<Toolbar {items} onclick={handler} />

Here, the items array defines two button controls with IDs name and email. The onclick event is triggered when a user clicks on any of these buttons. The handler function receives an event object containing the item (the control that was clicked). The control's ID is logged to the console, enabling developers to identify which button was clicked and execute corresponding actions.

Custom components​

The toolbar widget allows developers to extend its functionality by creating and integrating custom components. These components can be registered and utilized to create customized toolbar elements, such as buttons or input fields, tailored to specific application needs.

Registering a custom component as a Toolbar element​

Developers can register custom components as toolbar elements to enhance the toolbar's functionality. This feature is useful when creating reusable components that can be referenced across toolbars.

<script>
import { Toolbar, registerToolbarItem } from "@svar-ui/svelte-toolbar";
import { Text } from "@svar-ui/svelte-core";

// register custom component
registerToolbarItem("text", Text);
</script>

<Toolbar
items={[
{ id: "label", text: "Toolbar with text input" },
{ id: "search", comp: "text" },
]}
/>

In this case, the Text component is registered with the identifier "text". Once registered, the component can be used in the items array of the Toolbar by specifying its identifier in the comp property. This approach allows the inclusion of predefined or externally created components seamlessly in the toolbar.

Registering a separate renderer for the overflow menu​

The overflow menu appears automatically when the toolbar doesn't have enough space to show all items. By default, a component registered with registerToolbarItem() looks the same both in the toolbar and in the overflow menu. To give menu items a different look, register a separate component for the menu mode and pass { menu: true } as the third argument to the function.

<script>
import { Toolbar, ButtonList, registerToolbarItem } from "@svar-ui/svelte-toolbar";
import { Segmented } from "@svar-ui/svelte-core";

// register component for the `toolbar` mode
registerToolbarItem("segmented", Segmented);
// register a separate component for the `menu` mode
registerToolbarItem("segmented", ButtonList, { menu: true });

function onClick(item) {
message = "Button '" + item.id + "' clicked";
}

let items = [
// ... more toolbar items
{
id: "mode",
comp: "segmented",
value: "1",
options: [
{ id: "1", label: "All" },
{ id: "2", label: "Active" },
],
handler: onClick,
},
];
</script>

<Toolbar {items} />

Here, both Segmented and ButtonList are registered under the same "segmented" type. The toolbar item itself only needs to reference the shared type via comp: "segmented". The correct component is resolved automatically based on the item's current location without any extra logic on the application side:

  • Segmented view is used when the item is rendered directly in the toolbar

  • ButtonList view is used if the same item collapses into the overflow menu

Creating a custom button control for the Toolbar​

Custom button controls can be created to enhance user interaction within the toolbar. This functionality is helpful for buttons with specific styles or behaviors.

Definition in myControl.svelte​

<script>
export let menu;
export let text;
</script>

<button class:menu onclick>{text}</button>

<style>
.menu {
font-weight: bold;
}
</style>

This custom button component accepts two properties:

  • menu, which determines if the button is part of a popup menu (true when inside a menu).
  • text, which specifies the button's label.

The button emits an onclick event when clicked. The menu property is used to apply additional styles, as demonstrated by the menu class.

Usage in App.svelte​

<script>
import { Toolbar, registerToolbarItem } from "@svar-ui/svelte-toolbar";
import MyControl from "./MyControl.svelte";

// register custom component
registerToolbarItem("cb", MyControl);
</script>

<Toolbar
items={[
{ id: "label", text: "Toolbar with custom button" },
{ id: "search", comp: "cb" },
]}
/>

Here, the custom button is registered with the identifier "cb" and included in the toolbar by referencing it in the items array. Additional properties can be added to the item object and will be accessible in the custom button component.

Creating a Custom Input Control for the Toolbar​

Custom input controls can be created to allow data entry directly within the toolbar. This is useful for search fields, text inputs, or other editable fields.

Definition in myControl.svelte​

<script>
export let value;
export let type = "text";
</script>

<input type="text" bind:value />

This custom input component supports the following:

  • value property, which holds the initial input value and updates the toolbar's state when modified.
  • type property, which defaults to "text" and determines the input type.

Any additional properties defined in the item object will also be accessible in the component.

Usage in App.svelte​

<script>
import { Toolbar, registerToolbarItem } from "@svar-ui/svelte-toolbar";
import MyControl from "./MyControl.svelte";

// register custom component
registerToolbarItem("ci", MyControl);
</script>

<Toolbar
items={[
{ id: "label", text: "Toolbar with custom input" },
{ id: "search", comp: "ci", type: "search" },
]}
/>

The custom input control is registered with the identifier "ci". It is then used in the toolbar with properties like type set in the items array. This enables the creation of specialized input fields, such as a search bar.

Toolbar initialization and control management​

The toolbar widget allows developers to initialize a customizable toolbar and manage the values of its controls. The following sections explain how to set up the toolbar, retrieve control values, set initial values, and dynamically update control values.

Toolbar initialization​

The toolbar can be initialized with predefined items such as labels, spacers, and buttons. Each item can be customized with properties like id, text, comp (component type), icon, and css classes. Event handling is supported to capture user interactions.

<script>
import { Toolbar } from "@svar-ui/svelte-toolbar";

const items = [
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
},
];

function handler(ev) {
console.log(`item ${ev.id} was clicked`);
}
</script>

<Toolbar {items} onclick={handler} />

This setup is useful for creating a toolbar with a combination of static labels, flexible spacers, and interactive buttons. The handler function logs the id of the clicked item, enabling easy tracking of user actions.

Retrieving current control values​

The toolbar allows binding to a values object to track the current state of its controls. This can be used to monitor user inputs or selections in real time.

<script>
let values = {};

// will be triggered on changes
$: console.log(JSON.stringify(values));
</script>

<Toolbar
items={[
{ comp: Text, key: "query" },
{ comp: Switch, key: "state" },
]}
bind:values
/>

This functionality is suitable for dynamic interfaces where control states need to be observed and logged. For example, it can be used to capture a search query and a toggle state simultaneously.

Setting initial values for controls​

Initial values for toolbar controls can be predefined by passing a values object during initialization. The keys in the values object should match the key properties of the toolbar items.

<script>
const values = { query: "something else", state: true };
</script>

<Toolbar
items={[
{ comp: Text, key: "query" },
{ comp: Switch, key: "state" },
]}
{values}
/>

This feature is especially useful for preloading a toolbar with default settings, such as a predefined search term or an active toggle switch.

Modifying control values dynamically​

Control values in the toolbar can be updated programmatically by modifying the values object. This allows developers to reset or change control states based on application logic.

<script>
const items = [
{ type: "label", text: "Active Mode" },
{ comp: Switch, key: "state" },
];

let values = { query: "something else", state: true };

// change value later on
const reset = () => {
values = { ...values, state: false };
};
</script>

<Toolbar {items} {values} />

This capability is ideal for scenarios where controls need to be reset or updated dynamically, such as toggling between different modes or clearing user inputs.

Samples​

Toolbar samples

Styling a toolbar​

You can apply custom styles to Toolbar by providing a CSS class name via the css property and defining the desired styles in a <style> block:

<div class="demo-box">
<Toolbar {items} {values} css="my-class" />
</div>

<style>
.demo-box :global(.my-class) {
background-color: gold;
}
</style>

Svelte styles apply only to the current component's elements. Use :global() to target elements inside SVAR controls. To make the selector more specific, include the HTML tag name before the class.

Skip to main content

Toolbar widget

The Toolbar widget is a component used for creating button and icon panels in web applications.

It allows developers to easily integrate interactive toolbars into their user interfaces.

The widget is licensed under the MIT license.

Quick start

First steps

To start with the widget, add the necessary package to your project first.

npm install @svar-ui/vue-core
npm install @svar-ui/vue-toolbar

or

yarn add @svar-ui/vue-core
yarn add @svar-ui/vue-toolbar

Now, import the widget into your project.

<script setup>
import { Willow } from '@svar-ui/vue-core';
import { Toolbar } from '@svar-ui/vue-toolbar';
</script>

<template>
<Willow>
<Toolbar />
</Willow>
</template>

The Willow component is a default theme wrapper that adds necessary styles for all SVAR widgets. The Toolbar component may work without it, but it will not have any styles, and it will be necessary to add them manually. It is a common approach to add the Willow tag once at the top level of the application.

Full init code

To see the widget in action, add some items to the toolbar.

<script setup>
import { Toolbar } from "@svar-ui/vue-toolbar";
import { Willow } from '@svar-ui/vue-core';

const items = [
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
},
];

function handler(ev) {
console.log(`item ${ev.id} was clicked`);
}
</script>

<template>
<Willow>
<Toolbar :items="items" :onclick="handler" />
</Willow>
</template>

Toolbar

note

Make sure you apply a theme if you use the Toolbar component standalone. Please, refer to applying a theme for more information.

Visual themes

The widget is provided in two visual styles - Light and Dark, which are controlled by the theme tag.

<script setup>
import { Willow, WillowDark } from "@svar-ui/vue-core";
import { Toolbar } from "@svar-ui/vue-toolbar";
</script>

<template>
<!-- Light -->
<Willow>
<Toolbar />
</Willow>

<!-- Dark -->
<WillowDark>
<Toolbar />
</WillowDark>
</template>

Toolbar dark themes

Defining toolbar elements

The toolbar widget provides the ability to include various components, such as buttons, icons, labels, and form elements. These components can be configured and customized to suit specific application needs. Below are examples demonstrating how to define different components in the toolbar.

Adding a button to the Toolbar

<script setup>
const items = [
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
handler: onClick,
},
];
</script>

<template>
<Toolbar :items="items" />
</template>

Buttons are suitable for triggering actions or events, such as submitting forms or performing searches. The id uniquely identifies the button, comp specifies the type as "button", and icon adds a predefined icon. The optional css parameter can control the button's alignment, and handler assigns a function for handling click events.

Adding an icon to the Toolbar

<template>
<Toolbar :items="[{ comp: 'icon', icon: 'wxi-search' }]" />
</template>

Icons can be used to display visual cues or shortcuts. The comp property defines the component type as "icon", and icon assigns the specific visual representation. This is useful for adding static icons without additional functionality.

Adding a label to the Toolbar

<template>
<Toolbar :items="[{ text: 'My App' }]" />
</template>

Labels are ideal for displaying static text, such as the application name or section titles. The text property holds the displayed text content.

Adding a checkbox to the Toolbar

<script setup>
import { Checkbox } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar :items="[{ id: 'check', comp: Checkbox }]" :values="{ check: true }" />
</template>

Checkboxes are used for binary choices, such as toggling features on or off. The comp property specifies the Checkbox component, and values provides the initial checked state.

Adding a combo box to the Toolbar

<script setup>
import { Combo } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar
:items="[
{
id: 'lead',
comp: Combo,
options: [
{ id: 1, label: 'Kristina' },
{ id: 2, label: 'Dorian' },
],
},
]"
:values="{ lead: 1 }"
/>
</template>

Combo boxes allow users to select a value from a dropdown list. The comp property references the Combo component, and options defines the selectable items. The values property sets the initial selection.

Toolbar combo

Adding a datepicker to the Toolbar

<script setup>
import { Datepicker } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar :items="[{ id: 'date', comp: Datepicker }]" :values="{ date: new Date() }" />
</template>

Datepickers enable users to select dates. The comp property specifies the Datepicker component, and values sets the default date.

Toolbar datepicker

Adding a radio group to the Toolbar

<script setup>
import { RadioGroup } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar
:items="[
{
id: 'radio',
comp: RadioGroup,
options: [
{ id: 1, label: 'Kristina' },
{ id: 2, label: 'Dorian' },
],
},
]"
:values="{ radio: 1 }"
/>
</template>

Radio groups are ideal for selecting a single option from multiple choices. The comp references the RadioGroup component, and options defines the available choices. The values property determines the default selection.

Toolbar radiogroup

Adding a richselect to the Toolbar

<script setup>
import { Richselect } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar
:items="[
{
id: 'lead',
comp: Richselect,
options: [
{ id: 1, label: 'Kristina' },
{ id: 2, label: 'Dorian' },
],
},
]"
:values="{ lead: 1 }"
/>
</template>

Richselect components are advanced dropdowns with enhanced styling and interaction. The comp specifies Richselect, and options provides the dropdown items. The values sets the initial selected item.

Toolbar richselect

Adding a slider to the Toolbar

<script setup>
import { Slider } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar
:items="[{ id: 'limit', comp: Slider, min: 2, max: 20 }]"
:values="{ limit: 10 }"
/>
</template>

Sliders are used for selecting values within a range. The comp references the Slider component, min and max define the range, and values sets the initial value.

Toolbar slider

Adding a text input to the Toolbar

<script setup>
import { Text } from "@svar-ui/vue-core";
</script>

<template>
<Toolbar :items="[{ id: 'name', comp: Text }]" :values="{ name: 'John' }" />
</template>

Text inputs allow users to enter text data. The comp specifies the Text component, and values sets the default text. This is useful for capturing user input, such as names or search queries.

Toolbar text

Grouping items

The toolbar widget offers flexible options for grouping items in rows, columns, or a combination of both. This allows developers to organize buttons, icons, and other elements in layouts that fit the application's interface requirements.

The layout field on a group item controls the flex direction within that group. To change the orientation of the entire toolbar, use the top-level layout prop (see Changing Toolbar orientation).

Defining a group of items in a row

<template>
<Toolbar
:items="[
{ label: 'My App' },
{
layout: 'row',
items: [
{ comp: 'icon', id: 'add', icon: 'wxi-plus' },
{ comp: 'icon', id: 'edit', icon: 'wxi-pencil' },
{ comp: 'icon', id: 'delete', icon: 'wxi-trash' },
],
},
]"
/>
</template>

Group of items in a row

This configuration organizes toolbar items in a horizontal layout. Each icon (add, edit, delete) appears in a single row. It is suitable for cases where users need to access multiple related actions side by side, such as editing or managing items in a list.

Defining a group of items in a column

<template>
<Toolbar
:items="[
{ label: 'My App' },
{
layout: 'column',
items: [
{ comp: 'icon', id: 'add', icon: 'wxi-plus' },
{ comp: 'icon', id: 'edit', icon: 'wxi-pencil' },
{ comp: 'icon', id: 'delete', icon: 'wxi-trash' },
],
},
]"
/>
</template>

Group of items in a column

In this example, toolbar items are grouped into a vertical layout. Each icon is displayed one below the other. This layout works well in situations where space is constrained horizontally or when grouping actions in a sidebar.

Creating a multiline Toolbar

<template>
<Toolbar
:items="[
{
layout: 'column',
items: [
{
layout: 'row',
items: [
{
id: 'font-family',
comp: 'richselect',
},
{
id: 'font-size',
comp: 'richselect',
},
],
},
{
layout: 'row',
items: [
{
id: 'font-bold',
comp: 'icon',
icon: 'wxi-bold',
},
{
id: 'font-italic',
comp: 'icon',
icon: 'wxi-italic',
},
{
id: 'font-underline',
comp: 'icon',
icon: 'wxi-underline',
},
],
},
],
},
]"
/>
</template>

Multiline toolbar

This setup creates a toolbar with multiple rows grouped into a column layout. The first row contains dropdowns for font-family and font-size, while the second row includes buttons for text formatting (bold, italic, underline). It is ideal for text editors or similar applications where controls are grouped by functionality.

Mixing columns and rows in a Toolbar

<template>
<Toolbar
:items="[
{ id: 'label', text: 'My App' },
{
layout: 'column',
items: [
{ text: 'Actions' },
{
layout: 'row',
items: [
{
comp: 'icon',
icon: 'wxi-search',
},
{
comp: 'icon',
icon: 'wxi-trash',
},
],
},
],
},
]"
/>
</template>

Mixed column and row layout

This configuration combines column and row layouts.

Toolbar layout

Options for organizing and displaying items within the toolbar. These functionalities allow developers to structure toolbar items effectively for better usability and adaptability across different screen sizes.

Changing Toolbar orientation

By default, the Toolbar arranges its top-level items horizontally. Use the layout prop to make the entire toolbar vertical.

<template>
<Toolbar layout="column" :items="[...]" />
</template>

Vertical toolbar

This differs from item.layout, which controls the flex direction inside a single group, not the toolbar container itself.

Adding a separator between Toolbar items

<template>
<Toolbar
:items="[
{ comp: 'icon', icon: 'wxi-search' },
{ comp: 'separator' },
{ comp: 'icon', icon: 'wxi-plus' },
]"
/>
</template>

Separators are used to create visual divisions between toolbar items. This is useful for grouping related actions or icons, making the interface more organized and easier to navigate. In the above example, a separator is placed between two icons to visually distinguish their functionalities.

Aligning Toolbar items to the right

<template>
<Toolbar
:items="[
{ id: 'label', text: 'My App' },
{ comp: 'spacer' },
{
comp: 'icon',
icon: 'wxi-search',
css: 'right',
},
]"
/>
</template>

A spacer component can be used to push items such as icons or buttons to the right side of the toolbar. This approach is commonly applied to balance the layout, for example, placing a logo or title on the left and actionable icons on the right.

Collapsing button groups into an icon on overflow

<template>
<Toolbar
overflow="collapse"
:items="[
{
id: 'font-family',
comp: 'richselect',
},
{
id: 'font-size',
comp: 'richselect',
},
{
layout: 'row',
items: [
{
id: 'font-bold',
comp: 'icon',
icon: 'wxi-bold',
},
{
id: 'font-italic',
comp: 'icon',
icon: 'wxi-italic',
},
{
id: 'font-underline',
comp: 'icon',
icon: 'wxi-underline',
},
],
},
]"
/>
</template>

Collapsed toolbar group on overflow

When the toolbar cannot display all items due to limited screen space, grouped buttons can collapse into a single icon. This functionality is essential for creating responsive toolbars that adapt to smaller screens. Groups should be defined with a layout: "row" block to enable this behavior. For collapsing the entire toolbar, all items should be wrapped in a top-level row block.

Wrapping toolbar items to the next line on overflow

<template>
<Toolbar overflow="wrap" />
</template>

The default behavior of the toolbar is to wrap items to the next line when there is not enough space. This approach works well for toolbars that need to display all items without hiding or collapsing them, ensuring visibility at all times.

Moving overflow items into a popup menu

<template>
<Toolbar overflow="menu" />
</template>

Items that cannot fit into the visible toolbar can be moved into a popup menu. This is useful for reducing visual clutter while still providing access to all toolbar options. The overflow menu is particularly effective in scenarios where a clean appearance is prioritized.

Pinning items to prevent overflow hiding

When overflow="menu" is active, individual items can be pinned so they always remain visible in the toolbar regardless of available space. Set pinned: true on any item to keep it out of the overflow menu.

<template>
<Toolbar
overflow="menu"
:items="[
{ id: 'search', comp: 'icon', icon: 'wxi-search' },
{ id: 'copy', comp: 'icon', icon: 'wxi-content-copy', menuText: 'Copy' },
{ id: 'edit', comp: 'icon', icon: 'wxi-edit-outline', menuText: 'Edit', pinned: true },
{ id: 'delete', comp: 'icon', icon: 'wxi-delete-outline', pinned: true },
]"
/>
</template>

The widget allows for the management of controls in a popup menu by enabling the grouping of elements and customizing the appearance of the popup container. It provides flexibility in organizing and styling toolbar components.

Moving controls to a popup panel

By grouping controls into a "collapsed" layout, these controls are hidden by default and represented by an icon. Clicking the icon expands the group into a popup menu, displaying its content. This feature is useful for organizing toolbar items when screen space is limited or to improve accessibility by grouping related actions.

<template>
<Toolbar
:items="[
{ id: 'label', text: 'My App' },
{
layout: 'row',
collapsed: true,
icon: 'wxi-group',
text: 'Actions',
items: [
{
comp: 'icon',
icon: 'wxi-search',
},
{
comp: 'icon',
icon: 'wxi-trash',
},
],
},
]"
/>
</template>

Controls moved to popup panel

In this example, the toolbar includes a label "My App" and a collapsed group labeled "Actions". The group is represented by the "wxi-group" icon. This setup is beneficial for creating a clean and compact toolbar while still providing access to essential tools.

Defining a CSS class for the popup menu container

A custom CSS class can be applied to the top container of the popup menu to modify its appearance. This is helpful when the default styling does not meet the design requirements, allowing for a tailored look and feel.

<template>
<Toolbar menuCss="somemenu" />
</template>

<style>
.somemenu {
background-color: #f0f0f0;
}
</style>

In this snippet, the menuCss property is used to assign the "somemenu" class to the popup menu container. The associated CSS rule changes the background color of the popup menu to a light gray (#f0f0f0). This technique is practical for aligning the popup menu's appearance with the overall application theme or branding.

Event handling

The Toolbar widget provides methods to detect and respond to user interactions with its controls. Developers can use these methods to handle changes in control values and detect when specific controls are clicked.

Detecting changes in control values

This feature allows tracking when a user modifies the value of a control, such as a text input field. It is useful for scenarios like form building or data entry applications, where immediate feedback or processing is required upon value changes.

<script setup>
import { Text } from "@svar-ui/vue-core";

const items = [
{ id: "name", comp: Text },
{ id: "email", comp: Text },
];
function handler(ev) {
const { item, value } = ev;
console.log("changed control", item.id);
console.log("new value", value);
}
</script>

<template>
<Toolbar :items="items" :onchange="handler" />
</template>

In this example, the items array defines two controls with IDs name and email, both using the Text component. The onchange event is triggered whenever the value of a control changes. The handler function receives an event object containing the item (the control) and the new value. This information is logged to the console, but it can be used for further processing or validation.

Detecting clicks on controls

This functionality is used to capture user clicks on controls, such as buttons. It is commonly applied in interactive toolbars where actions need to be performed when a button is pressed.

<script setup>
const items = [
{ id: "name", comp: "button" },
{ id: "email", comp: "button" },
];
function handler(ev) {
const { item } = ev;
console.log("clicked control", item.id);
}
</script>

<template>
<Toolbar :items="items" :onclick="handler" />
</template>

Here, the items array defines two button controls with IDs name and email. The onclick event is triggered when a user clicks on any of these buttons. The handler function receives an event object containing the item (the control that was clicked). The control's ID is logged to the console, enabling developers to identify which button was clicked and execute corresponding actions.

Custom components

The toolbar widget allows developers to extend its functionality by creating and integrating custom components. These components can be registered and utilized to create customized toolbar elements, such as buttons or input fields, tailored to specific application needs.

Registering a custom component as a Toolbar element

Developers can register custom components as toolbar elements to enhance the toolbar's functionality. This feature is useful when creating reusable components that can be referenced across toolbars.

<script setup>
import { Toolbar, registerToolbarItem } from "@svar-ui/vue-toolbar";
import { Text } from "@svar-ui/vue-core";

// register custom component
registerToolbarItem("text", Text);
</script>

<template>
<Toolbar
:items="[
{ id: 'label', text: 'Toolbar with text input' },
{ id: 'search', comp: 'text' },
]"
/>
</template>

In this case, the Text component is registered with the identifier "text". Once registered, the component can be used in the items array of the Toolbar by specifying its identifier in the comp property. This approach allows the inclusion of predefined or externally created components seamlessly in the toolbar.

Registering a separate renderer for the overflow menu

The overflow menu appears automatically when the toolbar doesn't have enough space to show all items. By default, a component registered with registerToolbarItem() looks the same both in the toolbar and in the overflow menu. To give menu items a different look, register a separate component for the menu mode and pass { menu: true } as the third argument to the function.

<script setup>
import { Toolbar, ButtonList, registerToolbarItem } from "@svar-ui/vue-toolbar";
import { Segmented } from "@svar-ui/vue-core";

// register component for the `toolbar` mode
registerToolbarItem("segmented", Segmented);
// register a separate component for the `menu` mode
registerToolbarItem("segmented", ButtonList, { menu: true });

function onClick(item) {
message.value = "Button '" + item.id + "' clicked";
}

const items = [
// ... more toolbar items
{
id: "mode",
comp: "segmented",
value: "1",
options: [
{ id: "1", label: "All" },
{ id: "2", label: "Active" },
],
},
];
</script>

<template>
<Toolbar :items="items" />
</template>

Here, both Segmented and ButtonList are registered under the same "segmented" type. The toolbar item itself only needs to reference the shared type via comp: "segmented". The correct component is resolved automatically based on the item's current location without any extra logic on the application side:

  • Segmented view is used when the item is rendered directly in the toolbar

  • ButtonList view is used if the same item collapses into the overflow menu

Creating a custom button control for the Toolbar

Custom button controls can be created to enhance user interaction within the toolbar. This functionality is helpful for buttons with specific styles or behaviors.

Definition in myControl.vue

<script setup>
const props = defineProps({ menu: {}, text: {} });
</script>

<template>
<button :class="{ menu: props.menu }" :onclick="props.onclick">{{ props.text }}</button>
</template>

<style scoped>
.menu {
font-weight: bold;
}
</style>

This custom button component accepts two properties:

  • menu, which determines if the button is part of a popup menu (true when inside a menu).
  • text, which specifies the button's label.

The button fires an onclick callback prop when clicked. The menu property is used to apply additional styles, as demonstrated by the menu class.

Usage in App.vue

<script setup>
import { Toolbar, registerToolbarItem } from "@svar-ui/vue-toolbar";
import MyControl from "./MyControl.vue";

// register custom component
registerToolbarItem("cb", MyControl);
</script>

<template>
<Toolbar
:items="[
{ id: 'label', text: 'Toolbar with custom button' },
{ id: 'search', comp: 'cb' },
]"
/>
</template>

Here, the custom button is registered with the identifier "cb" and included in the toolbar by referencing it in the items array. Additional properties can be added to the item object and will be accessible in the custom button component.

Creating a Custom Input Control for the Toolbar

Custom input controls can be created to allow data entry directly within the toolbar. This is useful for search fields, text inputs, or other editable fields.

Definition in myControl.vue

<script setup>
const value = defineModel('value');
const props = defineProps({ type: { default: 'text' } });
</script>

<template>
<input :type="props.type" v-model="value" />
</template>

This custom input component supports the following:

  • value property, which holds the initial input value and updates the toolbar's state when modified.
  • type property, which defaults to "text" and determines the input type.

Any additional properties defined in the item object will also be accessible in the component.

Usage in App.vue

<script setup>
import { Toolbar, registerToolbarItem } from "@svar-ui/vue-toolbar";
import MyControl from "./MyControl.vue";

// register custom component
registerToolbarItem("ci", MyControl);
</script>

<template>
<Toolbar
:items="[
{ id: 'label', text: 'Toolbar with custom input' },
{ id: 'search', comp: 'ci', type: 'search' },
]"
/>
</template>

The custom input control is registered with the identifier "ci". It is then used in the toolbar with properties like type set in the items array. This enables the creation of specialized input fields, such as a search bar.

Toolbar initialization and control management

The toolbar widget allows developers to initialize a customizable toolbar and manage the values of its controls. The following sections explain how to set up the toolbar, retrieve control values, set initial values, and dynamically update control values.

Toolbar initialization

The toolbar can be initialized with predefined items such as labels, spacers, and buttons. Each item can be customized with properties like id, text, comp (component type), icon, and css classes. Event handling is supported to capture user interactions.

<script setup>
import { Toolbar } from "@svar-ui/vue-toolbar";

const items = [
{ id: "label", text: "My App" },
{ comp: "spacer" },
{
id: "search",
comp: "button",
icon: "wxi-search",
css: "right",
},
];

function handler(ev) {
console.log(`item ${ev.id} was clicked`);
}
</script>

<template>
<Toolbar :items="items" :onclick="handler" />
</template>

This setup is useful for creating a toolbar with a combination of static labels, flexible spacers, and interactive buttons. The handler function logs the id of the clicked item, enabling easy tracking of user actions.

Retrieving current control values

The toolbar allows binding to a values object to track the current state of its controls. This can be used to monitor user inputs or selections in real time.

<script setup>
import { ref, watch } from "vue";
import { Text, Switch } from "@svar-ui/vue-core";

const values = ref({});

// will be triggered on changes
watch(values, (v) => console.log(JSON.stringify(v)), { deep: true });
</script>

<template>
<Toolbar
:items="[
{ comp: Text, key: 'query' },
{ comp: Switch, key: 'state' },
]"
v-model:values="values"
/>
</template>

This functionality is suitable for dynamic interfaces where control states need to be observed and logged. For example, it can be used to capture a search query and a toggle state simultaneously.

Setting initial values for controls

Initial values for toolbar controls can be predefined by passing a values object during initialization. The keys in the values object should match the key properties of the toolbar items.

<script setup>
import { Text, Switch } from "@svar-ui/vue-core";

const values = { query: "something else", state: true };
</script>

<template>
<Toolbar
:items="[
{ comp: Text, key: 'query' },
{ comp: Switch, key: 'state' },
]"
:values="values"
/>
</template>

This feature is especially useful for preloading a toolbar with default settings, such as a predefined search term or an active toggle switch.

Modifying control values dynamically

Control values in the toolbar can be updated programmatically by modifying the values object. This allows developers to reset or change control states based on application logic.

<script setup>
import { ref } from "vue";
import { Switch } from "@svar-ui/vue-core";

const items = [
{ type: "label", text: "Active Mode" },
{ comp: Switch, key: "state" },
];

const values = ref({ query: "something else", state: true });

// change value later on
const reset = () => {
values.value = { ...values.value, state: false };
};
</script>

<template>
<Toolbar :items="items" :values="values" />
</template>

This capability is ideal for scenarios where controls need to be reset or updated dynamically, such as toggling between different modes or clearing user inputs.

Samples

Toolbar samples

Styling a toolbar

You can apply custom styles to Toolbar by providing a CSS class name via the css property and defining the desired styles in a <style> block:

<template>
<div class="demo-box">
<Toolbar :items="items" :values="values" css="my-class" />
</div>
</template>

<style>
.demo-box :global(.my-class) {
background-color: gold;
}
</style>

Vue styles in a component apply only to that component's elements by default when using <style scoped>. Use :global() to target elements inside SVAR controls. To make the selector more specific, include the HTML tag name before the class.